import sqlite3

def get_id_card_area(id_card):
    if len(id_card) < 6:
        raise ValueError("身份证号长度不足")

    area_code = id_card[:6]
    
    try:

        conn = sqlite3.connect('DB/area_format.db')
        cursor = conn.cursor()


        cursor.execute("SELECT name FROM areas WHERE id = ?", (area_code,))
        district = cursor.fetchone()
        if not district:
            return "未知地区"

        city_code = area_code[:4] + "00"
        cursor.execute("SELECT id, name FROM areas WHERE id = ?", (city_code,))
        city = cursor.fetchone()
        province_code = area_code[:2] + "0000"
        cursor.execute("SELECT id, name FROM areas WHERE id = ?", (province_code,))
        province = cursor.fetchone()

        municipalities = {'110000', '120000', '310000', '500000'}
        
        if province and province[0] in municipalities:
            return f"{province[1]}{district[0]}" 
        elif province and city:
            return f"{province[1]}{city[1]}{district[0]}"
        else:
            return district[0] 

    except sqlite3.Error as e:
        print(f"数据库查询错误: {e}")
        return "查询失败"
    finally:
        conn.close()