import os
import sys
import subprocess
from typing import List

REQUIRED_LIBRARIES = [
    "rich",
    "requests",
    "colorama",
    "tqdm",
    "importlib",
    "logging",
    "typing",
    "re",
    "random",
    "os",
    "time",
    "datetime",
    "concurrent.futures",
    "itertools",
    "subprocess"
]

def install_library(library: str) -> bool:
    print(f"正在安装库: {library}")
    try:
        subprocess.check_call([sys.executable, "-m", "pip", "install", library])
        print(f"库 {library} 安装成功！")
        return True
    except subprocess.CalledProcessError as e:
        print(f"库 {library} 安装失败: {e}")
        return False


def check_and_install_libraries(libraries: List[str]) -> None:
    for lib in libraries:
        try:
            __import__(lib)
            print(f"库 {lib} 已安装。")
        except ImportError:
            print(f"库 {lib} 未安装，尝试自动安装...")
            if not install_library(lib):
                print(f"无法安装库 {lib}，请手动安装！")


def initialize_toolbox() -> None:
    print("=== 开始初始化工具箱 ===")
    check_and_install_libraries(REQUIRED_LIBRARIES)
    print("=== 工具箱初始化完成 ===")


if __name__ == "__main__":
    initialize_toolbox()